- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# OsiGlpkSolverInterface Class Reference

`#include <OsiGlpkSolverInterface.hpp>`

Inheritance diagram for OsiGlpkSolverInterface:

[legend]
Collaboration diagram for OsiGlpkSolverInterface:

[legend]
List of all members.

## GLPK specific public interfaces
enum | keepCachedFlag { KEEPCACHED_NONE = 0, KEEPCACHED_COLUMN = 1, KEEPCACHED_ROW = 2, KEEPCACHED_MATRIX = 4, KEEPCACHED_RESULTS = 8, KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX, KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS, FREECACHED_COLUMN = KEEPCACHED_PROBLEM & ~KEEPCACHED_COLUMN, FREECACHED_ROW = KEEPCACHED_PROBLEM & ~KEEPCACHED_ROW, FREECACHED_MATRIX = KEEPCACHED_PROBLEM & ~KEEPCACHED_MATRIX, FREECACHED_RESULTS = KEEPCACHED_ALL & ~KEEPCACHED_RESULTS }
LPX * | getModelPtr ()
| Get pointer to GLPK model.
## Private member data
LPX * | lp_
| GPLK model represented by this class instance.
int | bbWasLast_
| GPLK model represented by this class instance.
int | maxIteration_
| simplex iteration limit (per call to solver)
int | hotStartMaxIteration_
| simplex iteration limit (for hot start)
int | nameDisc_
| OSI name discipline.
double | dualObjectiveLimit_
| dual objective limit (measure of badness; stop if we're worse)
double | primalObjectiveLimit_
| primal objective limit (measure of goodness; stop if we're better)
double | dualTolerance_
| dual feasibility tolerance
double | primalTolerance_
| primal feasibility tolerance
double | objOffset_
| constant offset for objective function
std::string | probName_
| Problem name.
void * | info_ [OsiLastHintParam]
| Array for info blocks associated with hints.
int | hotStartCStatSize_
| size of column status and value arrays
int * | hotStartCStat_
| column status array
double * | hotStartCVal_
| primal variable values
double * | hotStartCDualVal_
| dual variable values
int | hotStartRStatSize_
| size of row status and value arrays
int * | hotStartRStat_
| row status array
double * | hotStartRVal_
| row slack values
double * | hotStartRDualVal_
| row dual values
bool | isIterationLimitReached_
| glpk stopped on iteration limit
bool | isTimeLimitReached_
| glpk stopped on time limit
bool | isAbandoned_
| glpk abandoned the problem
bool | isObjLowerLimitReached_
| glpk stopped on lower objective limit
bool | isObjUpperLimitReached_
| glpk stopped on upper objective limit
bool | isPrimInfeasible_
| glpk declared the problem primal infeasible
bool | isDualInfeasible_
| glpk declared the problem dual infeasible
bool | isFeasible_
| glpk declared the problem feasible
static unsigned int | numInstances_
| number of GLPK instances currently in use (counts only those created by OsiGlpk)
## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter.
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter.
bool | setStrParam (OsiStrParam key, const std::string &value)
| Set a string parameter.
bool | setHintParam (OsiHintParam key, bool sense=true, OsiHintStrength strength=OsiHintTry, void *info=0)
| Set a hint parameter.
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter.
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter.
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter.
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
virtual bool | isTimeLimitReached () const
| Time limit reached?
virtual bool | isFeasible () const
| (Integer) Feasible solution found?
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get an empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes setColLower() and setColUpper().
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes setRowLower() and setRowUpper().
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes setRowLower() and setRowUpper() over and over again.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes setRowType() over and over again.
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
Methods for row and column names.
Only the set methods need to be overridden to ensure consistent names between OsiGlpk and the OSI base class.
void | setObjName (std::string name)
| Set the objective function name.
void | setRowName (int ndx, std::string name)
| Set a row name.
void | setColName (int ndx, std::string name)
| Set a column name.
Constructors and destructor
| OsiGlpkSolverInterface ()
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiGlpkSolverInterface (const OsiGlpkSolverInterface &)
| Copy constructor.
OsiGlpkSolverInterface & | operator= (const OsiGlpkSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiGlpkSolverInterface ()
| Destructor.
virtual void | reset ()
| Resets as if default constructor.
## Static Public Member Functions
Static instance counter methods
static void | incrementInstanceCounter ()
| GLPK has a context which must be freed after all GLPK LPs (or MIPs) are freed.
static void | decrementInstanceCounter ()
| GLPK has a context which must be freed after all GLPK LPs (or MIPs) are freed.
static unsigned int | getNumInstances ()
| Return the number of LP/MIP instances of instantiated objects using the GLPK environment.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied.
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment).
LPX * | getMutableModelPtr () const
| Pointer to the model.
## Private Member Functions
Private methods
void | gutsOfCopy (const OsiGlpkSolverInterface &source)
| The real work of a copy constructor (used by copy and assignment).
void | gutsOfConstructor ()
| The real work of the constructor.
void | gutsOfDestructor ()
| The real work of the destructor.
void | freeCachedColRim ()
| free cached column rim vectors
void | freeCachedRowRim ()
| free cached row rim vectors
void | freeCachedResults ()
| free cached result vectors
void | freeCachedMatrix ()
| free cached matrices
void | freeCachedData (int keepCached=KEEPCACHED_NONE)
| free all cached data (except specified entries, see getLpPtr())
void | freeAllMemory ()
| free all allocated memory
void | printBounds ()
| Just for testing purposes.
void | fillColBounds () const
| Fill cached collumn bounds.
## Private Attributes
Cached information derived from the GLPK model
int | iter_used_
| Number of iterations.
double * | obj_
| Pointer to objective vector.
double * | collower_
| Pointer to dense vector of variable lower bounds.
double * | colupper_
| Pointer to dense vector of variable lower bounds.
char * | ctype_
| Pointer to dense vector of variable types (continous, binary, integer).
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
double * | rowlower_
| Pointer to dense vector of row lower bounds.
double * | rowupper_
| Pointer to dense vector of row upper bounds.
double * | colsol_
| Pointer to primal solution vector.
double * | rowsol_
| Pointer to dual solution vector.
double * | redcost_
| Pointer to reduced cost vector.
double * | rowact_
| Pointer to row activity (slack) vector.
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients.
## Friends
int | OsiGlpkSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiGlpkSolverInterface class.

## Detailed Description

Definition at line 27 of file OsiGlpkSolverInterface.hpp.

## Member Enumeration Documentation

enum OsiGlpkSolverInterface::keepCachedFlag

Enumerator:

  KEEPCACHED_NONE | discard all cached data (default)
  KEEPCACHED_COLUMN | column information: objective values, lower and upper bounds, variable types
  KEEPCACHED_ROW | row information: right hand sides, ranges and senses, lower and upper bounds for row
  KEEPCACHED_MATRIX | problem matrix: matrix ordered by column and by row
  KEEPCACHED_RESULTS | LP solution: primal and dual solution, reduced costs, row activities.
  KEEPCACHED_PROBLEM | only discard cached LP solution
  KEEPCACHED_ALL | keep all cached data (similar to getMutableLpPtr())
  FREECACHED_COLUMN | free only cached column and LP solution information
  FREECACHED_ROW | free only cached row and LP solution information
  FREECACHED_MATRIX | free only cached matrix and LP solution information
  FREECACHED_RESULTS | free only cached LP solution information

Definition at line 628 of file OsiGlpkSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiGlpkSolverInterface::OsiGlpkSolverInterface | ( |  | ) |

Default Constructor.

OsiGlpkSolverInterface::OsiGlpkSolverInterface | ( | const OsiGlpkSolverInterface & |  | ) |

Copy constructor.

virtual OsiGlpkSolverInterface::~OsiGlpkSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiGlpkSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiGlpkSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiGlpkSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiGlpkSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Set a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiGlpkSolverInterface::setHintParam | ( | OsiHintParam | key,
|  | bool | sense = `true`,
|  | OsiHintStrength | strength = `OsiHintTry`,
|  | void * | info = `0` |
| ) |  |  | `[virtual]`

Set a hint parameter.

The `otherInformation` parameter can be used to pass in an arbitrary block of information which is interpreted by the OSI and the underlying solver. Users are cautioned that this hook is solver-specific.

Implementors: The default implementation completely ignores `otherInformation` and always throws an exception for OsiForceDo. This is almost certainly not the behaviour you want; you really should override this method.

Reimplemented from OsiSolverInterface.

bool OsiGlpkSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiGlpkSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiGlpkSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Get a string parameter.

Reimplemented from OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isTimeLimitReached | ( |  | ) | const`[virtual]`

Time limit reached?

virtual bool OsiGlpkSolverInterface::isFeasible | ( |  | ) | const`[virtual]`

(Integer) Feasible solution found?

CoinWarmStart* OsiGlpkSolverInterface::getEmptyWarmStart | ( |  | ) | const`[inline, virtual]`

Get an empty warm start object.

This routine returns an empty CoinWarmStartBasis object. Its purpose is to provide a way to give a client a warm start basis object of the appropriate type, which can resized and modified as desired.

Implements OsiSolverInterface.

Definition at line 110 of file OsiGlpkSolverInterface.hpp.

virtual CoinWarmStart* OsiGlpkSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiGlpkSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiGlpkSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiGlpkSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiGlpkSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiGlpkSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiGlpkSolverInterface::isContinuous | ( | int | colNumber | ) | const`[virtual]`

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiGlpkSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiGlpkSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiGlpkSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getRowPrice | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getReducedCost | ( |  | ) | const`[virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiGlpkSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiGlpkSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiGlpkSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiGlpkSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false` |
| ) |  |  | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiGlpkSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound
Use -DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound
Use DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single column lower and upper bound
The default implementation just invokes setColLower() and setColUpper().

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound
Use -DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound
Use DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single row lower and upper bound
The default implementation just invokes setRowLower() and setRowUpper().

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of rows simultaneously
The default implementation just invokes setRowLower() and setRowUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a number of rows simultaneously
The default implementation just invokes setRowType() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose any characteristics changes
  | senseList | the new senses
  | rhsList | the new right hand sides
  | rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiGlpkSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

void OsiGlpkSolverInterface::setObjName | ( | std::string | name | ) | `[virtual]`

Set the objective function name.

Reimplemented from OsiSolverInterface.

void OsiGlpkSolverInterface::setRowName | ( | int | ndx,
|  | std::string | name |
| ) |  |  | `[virtual]`

Set a row name.

Quietly does nothing if the name discipline (OsiNameDiscipline) is auto. Quietly fails if the row index is invalid.

Reimplemented from OsiSolverInterface.

void OsiGlpkSolverInterface::setColName | ( | int | ndx,
|  | std::string | name |
| ) |  |  | `[virtual]`

Set a column name.

Quietly does nothing if the name discipline (OsiNameDiscipline) is auto. Quietly fails if the column index is invalid.

Reimplemented from OsiSolverInterface.

LPX* OsiGlpkSolverInterface::getModelPtr | ( |  | ) |

Get pointer to GLPK model.

static void OsiGlpkSolverInterface::incrementInstanceCounter | ( |  | ) | `[inline, static]`

GLPK has a context which must be freed after all GLPK LPs (or MIPs) are freed.

It is automatically created when the first LP is created. This method:

- Increments by 1 the number of uses of the GLPK environment.

Definition at line 667 of file OsiGlpkSolverInterface.hpp.

References numInstances_.

static void OsiGlpkSolverInterface::decrementInstanceCounter | ( |  | ) | `[static]`

GLPK has a context which must be freed after all GLPK LPs (or MIPs) are freed.

This method:

- Decrements by 1 the number of uses of the GLPK environment.
- Deletes the GLPK environment when the number of uses is change to 0 from 1.

static unsigned int OsiGlpkSolverInterface::getNumInstances | ( |  | ) | `[inline, static]`

Return the number of LP/MIP instances of instantiated objects using the GLPK environment.

Definition at line 679 of file OsiGlpkSolverInterface.hpp.

References numInstances_.

virtual OsiSolverInterface* OsiGlpkSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiGlpkSolverInterface& OsiGlpkSolverInterface::operator= | ( | const OsiGlpkSolverInterface & | rhs | ) |

Assignment operator.

virtual void OsiGlpkSolverInterface::reset | ( |  | ) | `[virtual]`

Resets as if default constructor.

Reimplemented from OsiSolverInterface.

virtual void OsiGlpkSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiGlpkSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

LPX* OsiGlpkSolverInterface::getMutableModelPtr | ( |  | ) | const`[protected]`

Pointer to the model.

void OsiGlpkSolverInterface::gutsOfCopy | ( | const OsiGlpkSolverInterface & | source | ) | `[private]`

The real work of a copy constructor (used by copy and assignment).

void OsiGlpkSolverInterface::gutsOfConstructor | ( |  | ) | `[private]`

The real work of the constructor.

void OsiGlpkSolverInterface::gutsOfDestructor | ( |  | ) | `[private]`

The real work of the destructor.

void OsiGlpkSolverInterface::freeCachedColRim | ( |  | ) | `[private]`

free cached column rim vectors

void OsiGlpkSolverInterface::freeCachedRowRim | ( |  | ) | `[private]`

free cached row rim vectors

void OsiGlpkSolverInterface::freeCachedResults | ( |  | ) | `[private]`

free cached result vectors

void OsiGlpkSolverInterface::freeCachedMatrix | ( |  | ) | `[private]`

free cached matrices

void OsiGlpkSolverInterface::freeCachedData | ( | int | keepCached = `KEEPCACHED_NONE` | ) | `[private]`

free all cached data (except specified entries, see getLpPtr())

void OsiGlpkSolverInterface::freeAllMemory | ( |  | ) | `[private]`

free all allocated memory

void OsiGlpkSolverInterface::printBounds | ( |  | ) | `[private]`

Just for testing purposes.

void OsiGlpkSolverInterface::fillColBounds | ( |  | ) | const`[private]`

Fill cached collumn bounds.

## Friends And Related Function Documentation

int OsiGlpkSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiGlpkSolverInterface class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging.

## Member Data Documentation

LPX* OsiGlpkSolverInterface::lp_`[mutable, private]`

GPLK model represented by this class instance.

Definition at line 763 of file OsiGlpkSolverInterface.hpp.

unsigned int OsiGlpkSolverInterface::numInstances_`[static, private]`

number of GLPK instances currently in use (counts only those created by OsiGlpk)

Definition at line 766 of file OsiGlpkSolverInterface.hpp.

Referenced by getNumInstances(), and incrementInstanceCounter().

int OsiGlpkSolverInterface::bbWasLast_`[private]`

GPLK model represented by this class instance.

Definition at line 771 of file OsiGlpkSolverInterface.hpp.

int OsiGlpkSolverInterface::maxIteration_`[private]`

simplex iteration limit (per call to solver)

Definition at line 775 of file OsiGlpkSolverInterface.hpp.

int OsiGlpkSolverInterface::hotStartMaxIteration_`[private]`

simplex iteration limit (for hot start)

Definition at line 777 of file OsiGlpkSolverInterface.hpp.

int OsiGlpkSolverInterface::nameDisc_`[private]`

OSI name discipline.

Definition at line 779 of file OsiGlpkSolverInterface.hpp.

double OsiGlpkSolverInterface::dualObjectiveLimit_`[private]`

dual objective limit (measure of badness; stop if we're worse)

Definition at line 783 of file OsiGlpkSolverInterface.hpp.

double OsiGlpkSolverInterface::primalObjectiveLimit_`[private]`

primal objective limit (measure of goodness; stop if we're better)

Definition at line 785 of file OsiGlpkSolverInterface.hpp.

double OsiGlpkSolverInterface::dualTolerance_`[private]`

dual feasibility tolerance

Definition at line 787 of file OsiGlpkSolverInterface.hpp.

double OsiGlpkSolverInterface::primalTolerance_`[private]`

primal feasibility tolerance

Definition at line 789 of file OsiGlpkSolverInterface.hpp.

double OsiGlpkSolverInterface::objOffset_`[private]`

constant offset for objective function

Definition at line 791 of file OsiGlpkSolverInterface.hpp.

std::string OsiGlpkSolverInterface::probName_`[private]`

Problem name.

Definition at line 795 of file OsiGlpkSolverInterface.hpp.

void* OsiGlpkSolverInterface::info_[OsiLastHintParam]`[mutable, private]`

Array for info blocks associated with hints.

Definition at line 798 of file OsiGlpkSolverInterface.hpp.

int OsiGlpkSolverInterface::hotStartCStatSize_`[private]`

size of column status and value arrays

Definition at line 804 of file OsiGlpkSolverInterface.hpp.

int* OsiGlpkSolverInterface::hotStartCStat_`[private]`

column status array

Definition at line 806 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::hotStartCVal_`[private]`

primal variable values

Definition at line 808 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::hotStartCDualVal_`[private]`

dual variable values

Definition at line 810 of file OsiGlpkSolverInterface.hpp.

int OsiGlpkSolverInterface::hotStartRStatSize_`[private]`

size of row status and value arrays

Definition at line 813 of file OsiGlpkSolverInterface.hpp.

int* OsiGlpkSolverInterface::hotStartRStat_`[private]`

row status array

Definition at line 815 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::hotStartRVal_`[private]`

row slack values

Definition at line 817 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::hotStartRDualVal_`[private]`

row dual values

Definition at line 819 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isIterationLimitReached_`[private]`

glpk stopped on iteration limit

Definition at line 823 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isTimeLimitReached_`[private]`

glpk stopped on time limit

Definition at line 825 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isAbandoned_`[private]`

glpk abandoned the problem

Definition at line 827 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isObjLowerLimitReached_`[private]`

glpk stopped on lower objective limit

When minimising, this is the primal limit; when maximising, the dual limit.

Definition at line 833 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isObjUpperLimitReached_`[private]`

glpk stopped on upper objective limit

When minimising, this is the dual limit; when maximising, the primal limit.

Definition at line 839 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isPrimInfeasible_`[private]`

glpk declared the problem primal infeasible

Definition at line 841 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isDualInfeasible_`[private]`

glpk declared the problem dual infeasible

Definition at line 843 of file OsiGlpkSolverInterface.hpp.

bool OsiGlpkSolverInterface::isFeasible_`[private]`

glpk declared the problem feasible

Definition at line 845 of file OsiGlpkSolverInterface.hpp.

int OsiGlpkSolverInterface::iter_used_`[mutable, private]`

Number of iterations.

Definition at line 851 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::obj_`[mutable, private]`

Pointer to objective vector.

Definition at line 854 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::collower_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 857 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::colupper_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 860 of file OsiGlpkSolverInterface.hpp.

char* OsiGlpkSolverInterface::ctype_`[mutable, private]`

Pointer to dense vector of variable types (continous, binary, integer).

Definition at line 863 of file OsiGlpkSolverInterface.hpp.

char* OsiGlpkSolverInterface::rowsense_`[mutable, private]`

Pointer to dense vector of row sense indicators.

Definition at line 866 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::rhs_`[mutable, private]`

Pointer to dense vector of row right-hand side values.

Definition at line 869 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::rowrange_`[mutable, private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 872 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::rowlower_`[mutable, private]`

Pointer to dense vector of row lower bounds.

Definition at line 875 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::rowupper_`[mutable, private]`

Pointer to dense vector of row upper bounds.

Definition at line 878 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::colsol_`[mutable, private]`

Pointer to primal solution vector.

Definition at line 881 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::rowsol_`[mutable, private]`

Pointer to dual solution vector.

Definition at line 884 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::redcost_`[mutable, private]`

Pointer to reduced cost vector.

Definition at line 887 of file OsiGlpkSolverInterface.hpp.

double* OsiGlpkSolverInterface::rowact_`[mutable, private]`

Pointer to row activity (slack) vector.

Definition at line 890 of file OsiGlpkSolverInterface.hpp.

CoinPackedMatrix* OsiGlpkSolverInterface::matrixByRow_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 893 of file OsiGlpkSolverInterface.hpp.

CoinPackedMatrix* OsiGlpkSolverInterface::matrixByCol_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 896 of file OsiGlpkSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Alps-1.2.1/Osi/src/OsiGlpk/OsiGlpkSolverInterface.hpp